#pragma comment(linker, "/STACK:104857600")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <vector>
#include <cassert>
#include <algorithm>

// testlib is evil
#define stderr stdout

#include "testlib.h"

using namespace std;

typedef vector<vector<int> > graph_t;
graph_t g;

// Microsoft is evil too
inline int max1(int a, int b) { return a > b ? a : b; }

int visited;
int height(int v, int s, int t)
{
	visited++;
	int h = v == t ? height(s, s, t) : 0;
	auto &children = g[v];
	for (int i = 0; i < children.size(); i++)
		if (children[i] != s)
			h = max1(height(children[i], s, t), h);
	return h + 1;
}

int main(int argc, char **argv)
{
	registerTestlibCmd(argc, argv);

	int n = inf.readInt(1, 100000);
	int k = inf.readInt(1, 100000);

	g.resize(n + 1);
	vector<int> p;
	p.resize(n + 1);
	for (int i = 1; i <= n; i++) {
		p[i] = inf.readInt(0, n);
		g[p[i]].push_back(i);
		quitif(g[p[i]].size() > k, _fail, "Too many children for %d in input", p[i]);
	}
	visited = 0;
	height(0, -1, -1);
	quitif(visited != n + 1, _fail, "Broken input graph %d", visited);

	int s = ouf.readInt(1, n);
	int t = ouf.readInt(0, n);
	quitif(p[s] != t && g[t].size() >= k, _wa, "Too many children for %d", t);

	int sol_s = ans.readInt(1, n);
	int sol_t = ans.readInt(0, n);
	quitif(p[sol_s] != sol_t && g[sol_t].size() >= k, _fail, "Too many children for %d", sol_t);

	visited = 0;
	int h = height(0, s, t);
	quitif(visited != n + 1, _wa, "Broken graph %d", visited);

	visited = 0;
	int sol_h = height(0, sol_s, sol_t);
	quitif(visited != n + 1, _fail, "Broken graph %d", visited);

	quitif(sol_h < h, _wa, "Only h=%d instead of %d", h, sol_h);
	quitif(sol_h > h, _fail, "h=%d instead of %d", h, sol_h);
	quitf(_ok, "h=%d", h);
}
