#pragma comment(linker, "/STACK:104857600")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <utility>
#include <vector>
#include <queue>
 
using namespace std;
 
int n, k, r;
vector<vector<int>> graph;
vector<int> parent, weight;
priority_queue<pair<int, int>> q;
 
void dfs(int u, int w)
{
    q.push(make_pair(w, u));
    weight[u] = w;
    for (int i = 0; i < graph[u].size(); i++) dfs(graph[u][i], w + 1);
}
 
int bfs()
{
    queue<int> _q;
    _q.push(0);
    while (!_q.empty()) {
        int t = _q.front();
        _q.pop();
        if (graph[t].size() - (t == parent[r] ? 1 : 0) < k) return t;
        for (int i = 0; i < graph[t].size(); i++)
            _q.push(graph[t][i]);
    }
    return -1;
}
 
bool is_parent(int u, int v)
{
    while (v != 0 && weight[u] <= weight[v]) {
        if (u == v) return true;
        v = parent[v];
    }
    return false;
}
 
int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
 
    cin >> n >> k;
    graph.resize(n + 1);
    parent.resize(n + 1);
    weight.resize(n + 1);
 
    for (int i = 1; i <= n; i++) {
        int u; cin >> u;
        graph[u].push_back(i);
        parent[i] = u;
    }
 
    dfs(0, 0);
    int h = q.top().first;
    r = q.top().second;
    int min_free = bfs();
 
    while (r != 0) {
        while (is_parent(r, q.top().second)) q.pop();
        if (q.top().first <= h - weight[r] + weight[min_free] + 1) break;
        r = parent[r];
    }
 
    cout << r << ' ' << min_free;
 
    return 0;
}
